//+------------------------------------------------------------------+
//|                                        3LB Pivot Point Lines.mq4 |
//|                                                 Khashayar Talebi |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Khashayar Talebi"
#property link      ""

#property indicator_chart_window

extern int  period = 1440;
extern color R3 = DeepSkyBlue;
extern color R2 = DeepSkyBlue;
extern color R1 = DeepSkyBlue;
extern color Pivot = SpringGreen;
extern color S1 = Orange;
extern color S2 = Orange;
extern color S3 = Orange;
extern int Line_Width = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if (period == 0 || period == 1440) string name = "Daily";
   if (period == 10080 )   name = "Weekly";
   if (period == 43200)    name = "Monthly";   
  for ( int no = 1 ; no<=7 ; no++)
 {
 if (no==1){string line_name = "Pivot Point ( "+name+" )";   }
 if (no==2){       line_name = "Resistance 1 ( "+name+" )";  }
 if (no==3){       line_name = "Support 1 ( "+name+" )";     }
 if (no==4){       line_name = "Resistance 2 ( "+name+" )";  }
 if (no==5){       line_name = "Support 2 ( "+name+" )";     }
 if (no==6){       line_name = "Resistance 3 ( "+name+" )";  }
 if (no==7){       line_name = "Support 3 ( "+name+" )";     }     
 ObjectDelete(line_name);  
 } 
if(period < 1440 )
{Comment("");}
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
if(period == 1440 || period == 10080 || period == 43200 )
{
   if (period == 0 || period == 1440) string name = "D";
   if (period == 10080 )   name = "W";
   if (period == 43200)    name = "M";   
//----
 if (period==0)period=1440;
 
  double open  = iOpen (NULL,period,1);
  double high  = iHigh (NULL,period,1);
  double low   = iLow  (NULL,period,1);
  double close = iClose(NULL,period,1);
  
  int start =  iBarShift(NULL,Period(),iTime (NULL,period,0)) ;
  int finish = iBarShift(NULL,Period(),iTime (NULL,0,0));
  
  double pivotval = (high+low+close)/3; // no 1
  double r1val = 2*pivotval-low; // no 2
  double s1val = 2*pivotval-high; // no 3
  double r2val = pivotval+(r1val-s1val); // no 4
  double s2val = pivotval-(r1val-s1val); // no 5
  double r3val = high+2*(pivotval-low); // no 6
  double s3val = low-2*(high-pivotval); // no 7
  
 for ( int no = 1 ; no<=7 ; no++)
 {
 if (no==1){ double priceval = pivotval ; string line_name = "PP ( "+name+" )"; color l_Col =Pivot ;  }
 if (no==2){   priceval = r1val ;line_name = "R 1 ( "+name+" )";  l_Col =R1 ;  }
 if (no==3){   priceval = s1val ;line_name = "S 1 ( "+name+" )";     l_Col =S2 ;  }
 if (no==4){   priceval = r2val ;line_name = "R 2 ( "+name+" )";  l_Col =R2 ;  }
 if (no==5){   priceval = s2val ;line_name = "S 2 ( "+name+" )";     l_Col =S2 ;  }
 if (no==6){   priceval = r3val ;line_name = "R 3 ( "+name+" )";  l_Col =R3 ;  }
 if (no==7){   priceval = s3val ;line_name = "S 3 ( "+name+" )";     l_Col =S3 ;  }     
  if(ObjectFind(line_name)==-1)
  {
  ObjectCreate(line_name,OBJ_TREND,0,Time[iBarShift(NULL,Period(),iTime (NULL,period,0))],priceval,Time[iBarShift(NULL,Period(),iTime (NULL,0,0))],priceval);
  ObjectSet(line_name,6,l_Col);
  ObjectSet(line_name,7,2);
  ObjectSet(line_name,8,Line_Width);
  ObjectSet(line_name,10,false); 
  ObjectSetText(line_name,line_name); 
  }  
   if(ObjectFind(line_name)!=-1)
  {
    ObjectSet(line_name,0,Time[iBarShift(NULL,Period(),iTime (NULL,period,0))] );
    ObjectSet(line_name,1,priceval );
    ObjectSet(line_name,2,Time[iBarShift(NULL,Period(),iTime (NULL,0,0))] );
    ObjectSet(line_name,3,priceval );
      
    ObjectSet(line_name,6,l_Col);
    ObjectSet(line_name,7,2);
    ObjectSet(line_name,8,Line_Width);
    ObjectSet(line_name,10,false); 
    ObjectSetText(line_name,line_name);
  }
 
 }
 
}
else{Comment("!!! Wrong Period !!!");} 
 
 
 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+